// beeper.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>
#include <assert.h>
#include <math.h>


#define EX4_STOP_EVENT_NAME     _T("EX4.StopEvent")
#define EX4_BEEP_MUTEX_NAME     _T("EX4.BeepMutex")
#define TIMEOUT                 3000

int _tmain(int argc, _TCHAR* argv[])
{
	assert(argc == 3);

	DWORD freq  = _tstoi(argv[1]);
	DWORD delta = _tstoi(argv[2]);
    DWORD processId = GetCurrentProcessId();

    _tprintf(_T("Started [%d]\n"), processId);

    // manual reset event so both processes will have a chance to be alerted
	HANDLE hEvent = CreateEvent(NULL, TRUE, FALSE, EX4_STOP_EVENT_NAME);
	HANDLE hMutex = CreateMutex(NULL, FALSE, EX4_BEEP_MUTEX_NAME);
	assert((hEvent != NULL)  &&  (hMutex != NULL));

	BOOL bContinue = TRUE;
	DWORD dwCount = 0;

	while (bContinue)
	{
        // wait for mutex
		DWORD dwRes = WaitForSingleObject(hMutex, TIMEOUT);
		assert(dwRes == WAIT_OBJECT_0);

		// perform beep with given frequency and 500ml (half a second) duration
        _tprintf(_T("Beep [%d]\n"), processId);
		BOOL bRes = Beep(freq, 500);
		assert(bRes);

        // release mutex
        bRes = ReleaseMutex(hMutex);
		assert(bRes);

		// wait for delta timeout or untill event is signaled
		dwRes = WaitForSingleObject(hEvent, delta);

		bContinue = (dwRes != WAIT_OBJECT_0);

		dwCount++;
	}

    // close handles
	CloseHandle(hEvent);
	CloseHandle(hMutex);

	return dwCount;
}


